/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.core.domain.preferences {

    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import flash.utils.IExternalizable;
    import mx.collections.ListCollectionView;

    [Bindable]
    public class PreferencesBase implements IExternalizable {

        protected var _applicationOrRoleOrUserOrModule:ListCollectionView;
        protected var _applications:ListCollectionView;
        protected var _modules:ListCollectionView;
        protected var _roles:ListCollectionView;
        protected var _users:ListCollectionView;

        public function get applicationOrRoleOrUserOrModule():ListCollectionView {
            return _applicationOrRoleOrUserOrModule;
        }

        public function get applications():ListCollectionView {
            return _applications;
        }

        public function get modules():ListCollectionView {
            return _modules;
        }

        public function get roles():ListCollectionView {
            return _roles;
        }

        public function get users():ListCollectionView {
            return _users;
        }

        public function readExternal(input:IDataInput):void {
            _applicationOrRoleOrUserOrModule = input.readObject() as ListCollectionView;
            _applications = input.readObject() as ListCollectionView;
            _modules = input.readObject() as ListCollectionView;
            _roles = input.readObject() as ListCollectionView;
            _users = input.readObject() as ListCollectionView;
        }

        public function writeExternal(output:IDataOutput):void {
            output.writeObject(_applicationOrRoleOrUserOrModule);
            output.writeObject(_applications);
            output.writeObject(_modules);
            output.writeObject(_roles);
            output.writeObject(_users);
        }
    }
}