/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.core.domain.system.usermanagement {

    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import mx.collections.ListCollectionView;
    import org.granite.meta;

    use namespace meta;

    [Bindable]
    public class RoleBase extends SecurityObject {

        protected var _grants:ListCollectionView;
        protected var _immutable:Boolean;
        protected var _preferences:ListCollectionView;
        protected var _users:ListCollectionView;

        public function set grants(value:ListCollectionView):void {
            _grants = value;
        }
        public function get grants():ListCollectionView {
            return _grants;
        }

        public function get immutable():Boolean {
            return _immutable;
        }

        public function set preferences(value:ListCollectionView):void {
            _preferences = value;
        }
        public function get preferences():ListCollectionView {
            return _preferences;
        }

        public function set users(value:ListCollectionView):void {
            _users = value;
        }
        public function get users():ListCollectionView {
            return _users;
        }

        override public function readExternal(input:IDataInput):void {
            super.readExternal(input);
            if (meta::isInitialized()) {
                _grants = input.readObject() as ListCollectionView;
                _immutable = input.readObject() as Boolean;
                _preferences = input.readObject() as ListCollectionView;
                _users = input.readObject() as ListCollectionView;
            }
        }

        override public function writeExternal(output:IDataOutput):void {
            super.writeExternal(output);
            if (meta::isInitialized()) {
                output.writeObject(_grants);
                output.writeObject(_immutable);
                output.writeObject(_preferences);
                output.writeObject(_users);
            }
        }
    }
}