/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.core.domain.system.usermanagement {

    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import org.granite.meta;
    import org.granite.util.Enum;
    import org.openwms.core.domain.system.AbstractPreference;
    import org.openwms.core.domain.system.PropertyScope;

    use namespace meta;

    [Bindable]
    public class RolePreferenceBase extends AbstractPreference {

        protected var _key:String;
        protected var _owner:String;
        protected var _type:PropertyScope;

        public function get key():String {
            return _key;
        }

        public function get owner():String {
            return _owner;
        }

        public function get type():PropertyScope {
            return _type;
        }

        override public function readExternal(input:IDataInput):void {
            super.readExternal(input);
            if (meta::isInitialized()) {
                _key = input.readObject() as String;
                _owner = input.readObject() as String;
                _type = Enum.readEnum(input) as PropertyScope;
            }
        }

        override public function writeExternal(output:IDataOutput):void {
            super.writeExternal(output);
            if (meta::isInitialized()) {
                output.writeObject(_key);
                output.writeObject(_owner);
                output.writeObject(_type);
            }
        }
    }
}