/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.core.domain.system.usermanagement {

    import flash.utils.ByteArray;
    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import flash.utils.IExternalizable;
    import org.granite.util.Enum;
    import org.openwms.core.domain.values.ImageProvider;

    [Bindable]
    public class UserDetailsBase implements IExternalizable, ImageProvider {

        protected var _comment:String;
        protected var _department:String;
        protected var _description:String;
        protected var _image:ByteArray;
        protected var _office:String;
        protected var _phoneNo:String;
        protected var _sex:UserDetails$SEX;
        protected var _skypeName:String;

        public function set comment(value:String):void {
            _comment = value;
        }
        public function get comment():String {
            return _comment;
        }

        public function set department(value:String):void {
            _department = value;
        }
        public function get department():String {
            return _department;
        }

        public function set description(value:String):void {
            _description = value;
        }
        public function get description():String {
            return _description;
        }

        public function set image(value:ByteArray):void {
            _image = value;
        }
        public function get image():ByteArray {
            return _image;
        }

        public function set office(value:String):void {
            _office = value;
        }
        public function get office():String {
            return _office;
        }

        public function set phoneNo(value:String):void {
            _phoneNo = value;
        }
        public function get phoneNo():String {
            return _phoneNo;
        }

        public function set sex(value:UserDetails$SEX):void {
            _sex = value;
        }
        public function get sex():UserDetails$SEX {
            return _sex;
        }

        public function set skypeName(value:String):void {
            _skypeName = value;
        }
        public function get skypeName():String {
            return _skypeName;
        }

        public function readExternal(input:IDataInput):void {
            _comment = input.readObject() as String;
            _department = input.readObject() as String;
            _description = input.readObject() as String;
            _image = input.readObject() as ByteArray;
            _office = input.readObject() as String;
            _phoneNo = input.readObject() as String;
            _sex = Enum.readEnum(input) as UserDetails$SEX;
            _skypeName = input.readObject() as String;
        }

        public function writeExternal(output:IDataOutput):void {
            output.writeObject(_comment);
            output.writeObject(_department);
            output.writeObject(_description);
            output.writeObject(_image);
            output.writeObject(_office);
            output.writeObject(_phoneNo);
            output.writeObject(_sex);
            output.writeObject(_skypeName);
        }
    }
}