/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.core.domain.values {

    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import flash.utils.IExternalizable;

    [Bindable]
    public class I18nSetBase implements IExternalizable {

        protected var _deDe:String;
        protected var _enUs:String;
        protected var _frFr:String;

        public function get deDe():String {
            return _deDe;
        }

        public function get enUs():String {
            return _enUs;
        }

        public function get frFr():String {
            return _frFr;
        }

        public function readExternal(input:IDataInput):void {
            _deDe = input.readObject() as String;
            _enUs = input.readObject() as String;
            _frFr = input.readObject() as String;
        }

        public function writeExternal(output:IDataOutput):void {
            output.writeObject(_deDe);
            output.writeObject(_enUs);
            output.writeObject(_frFr);
        }
    }
}